<?php

class actionMypatchFileEdit extends cmsAction {
    
    public function run($file_id=false){

        $is_admin = cmsUser::isAdmin();
        if (!$is_admin) { cmsCore::error404(); }
        if (!$file_id) { cmsCore::error404(); }

        $mypatch_model = cmsCore::getModel('mypatch');
        
        $file = $mypatch_model->getPatchFile($file_id);
        if (!$file) { cmsCore::error404(); }
        
        $patch = $mypatch_model->getPatch($file['patch_id']);
        if (!$patch) { cmsCore::error404(); }
        
        $errors = false;
        
        $form = $this->getForm('file');
        
        $is_submitted = $this->request->has('submit');

        if ($is_submitted) {
            
            $file = $form->parse($this->request, $is_submitted);
            $errors = $form->validate($this, $file)   ;
         
            if (!$errors){
               $file['patch_id'] = $patch['id'];
               $mypatch_error = $mypatch_model->addPatchFile($file, $file_id);
               if ($mypatch_error['file_original'] == 1) {
               cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_NOFILE, 'error');
               }elseif ($mypatch_error['order_file'] == 1) {
               cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_ORDER_FILE, 'error');
               }elseif ($mypatch_error['shifts'] == 1) {
               cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_SHIFT, 'error');
               }elseif ($mypatch_error['shifts'] == 2) {
               cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_SHIFTS, 'error');
               }elseif ($mypatch_error['file_put']) {
               cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_ORIGINAL_CREATE, 'error');
               }else{
               $this->redirectToAction('files', array($patch['id']));                   
               }
            }
            
            if ($errors){
                cmsUser::addSessionMessage(LANG_FORM_ERRORS, 'error');
            }
            
        }    
        

        return cmsTemplate::getInstance()->render('backend/file', array(
            'do' => 'edit',
            'form' => $form,
            'file' => $file,
            'patch' => $patch,
            'errors' => $errors
       ));
       
       
    }
    
}

