<?php

class actionMypatchPatchUpload extends cmsAction {

    public function run($patch_id=false){
        $is_admin = cmsUser::isAdmin();
        if (!$is_admin) { cmsCore::error404(); }
        if (!$patch_id) { cmsCore::error404(); };
        
        $patchfile = $this->PatchSaveFile($patch_id);        
        $grid = $this->loadDataGrid('patch'); 
        return  cmsTemplate::getInstance()->render('backend/patchs', array(
            'grid' => $grid,
            'patchfile'=> $patchfile,
        ));


    }
    private function PatchSaveFile($patch_id=false) {           

        // вытягиваем данные
        $mypatch_model = cmsCore::getModel('mypatch');
        $files = $mypatch_model->getPatchFiles($patch_id);
        $patchs = $mypatch_model->getPatchs();
        $current_version = "[version]" . "\n" . cmsCore::getVersion() . "\n\n";

        
        //получаем данные о папки загрузки.
        $config = cmsConfig::getInstance();
        $upload_dir = $config->upload_root . "mypatch";
        //проверяем на наличе папки mypatch в папке загрузки файлов, если нет - создаем.
        if (!file_exists($config->root_path . $upload_dir)) {
            //обнуляем флаг резултата работы
            unset($result);
            //создаем папку кэша
            $result = mkdir($config->root_path . $upload_dir, 0777);
            // проверяем результат работы
            if (!$result) {
                $error['create_upload_dir'] = 1;
                return $error;
            }
        }

        //формируем строкову переменную из данных масива
        if ($files) {
            foreach ($files as $name => $code){

            $array_str = array_merge(array_slice($code, 5, 1),array_slice($code, 2, 3));

            $str = print_r($array_str, $return=true);
            $str = str_replace("    [","\n[", $str);
            $str = str_replace("] => ","]\n", $str);
            $str = str_replace("Array\n(","", $str);
            $str = str_replace(")\n","", $str);
            $string = "$string"."$str";
            }
        }
        // формируем описание
        $desc = print_r(array_slice($patchs[$patch_id],1,1), $return=true);
        $desc = str_replace("    [","[", $desc);
        $desc = str_replace("] => ","]\n", $desc);
        $desc = str_replace("Array\n(","", $desc);
        $desc = str_replace(")\n","", $desc);

        //обнуляем флаг резултата работы
        unset($result);
                
        //очищаем директорию от предыдущих файлов
        $src_dir = $config->root_path . $upload_dir . '/';
        $dirHandle = opendir($src_dir);
            while (false !== ($file_del = readdir($dirHandle))) {
                if ($file_del !== '.'){
                    if ($file_del !== '..'){
                        @unlink($src_dir . $file_del);
                    }
                }
            }
            
        //помещаем описание и данные в файл
        $filename = ID_ . $patch_id . '.patch';
        $file = $upload_dir . '/' . $filename;  //полный путь к файлу - имя файла, его ID
        $result = @file_put_contents($config->root_path . $file, $current_version.$desc.$string);
        
        //проверяем результат        
        if ($result){ 
            // архивируем файл
            $zipfilename = Patch_ID_ . $patch_id . '.zip';
            $filezip = $upload_dir . '/' . $zipfilename; //полный путь к файлу - имя файла, его ID
            $zip = new ZipArchive(); //Создаём объект для работы с ZIP-архивами
            $zip->open($config->root_path . $filezip, ZIPARCHIVE::CREATE); //Открываем (создаём) архив 
            $zip->addFile($config->root_path . $file, $filename); //Добавляем в архив файл
            $zip->close(); //Завершаем работу с архивом
            @unlink($config->root_path . $file); // удаляем входящий файл
            
            return $filezip;
        } else {
                $error['put_contents'] = 1;
                return $error;            
        }
    }  
}
