<?php

class actionMypatchReset extends cmsAction {

    public function run(){
        $is_admin = cmsUser::isAdmin();
        if (!$is_admin) { cmsCore::error404(); }
                
        $mypatch_error = $this->ResetFileOriginal();
        
        if ($mypatch_error['file_reset']){
            cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_ORIGINAL_RESET, 'error');
        } elseif ($mypatch_error['ftp_auth']){
            cmsUser::addSessionMessage(LANG_MYPATCH_CP_FTP_AUTH_FAILED, 'error');
            $this->redirectToAction('');
        } else {
            cmsUser::addSessionMessage(LANG_MYPATCH_RESET_OK, 'success');
        }

        $this->redirectToAction('');
    
    }
    
    private function ResetFileOriginal() {
        $mypatch_options = cmsController::loadOptions('mypatch');
        $mypatch_model = cmsCore::getModel('mypatch');
        $config = cmsConfig::getInstance();
        $files = $mypatch_model->getAllPatchFiles();
        
        $connection = @ftp_connect($mypatch_options['host'], $mypatch_options['port']);
        
        if (!$connection){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
        $session = @ftp_login($connection, $mypatch_options['user'], $mypatch_options['pass']);
        
        if (!$session){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
        if ($mypatch_options['is_pasv']) { ftp_pasv($connection, true); }
        
        foreach ($files as $file){
                        
            if (file_exists($config->root_path . $file['file_original'] . ".original")) {
                $file_reset = $mypatch_options['path'] . $file['file_original'] . ".original";
                $result = @ftp_delete($connection, $mypatch_options['path'] . $file['file_original']);
                if ($result) {
                    $result = @ftp_rename($connection, $file_reset, $mypatch_options['path'] . $file['file_original']);
                    if (!$result) { 
                        $error[] = $file['file_original']; 
                        $mypatch_model->changeStatePatching($file, $status = 'error');
                    }
                    if ($result) { 
                        @ftp_chmod($connection, 0644, $mypatch_options['path'] . $file['file_original']);
                        
                        $mypatch_model->changeStatePatching($file, $status = 'reset');
                    }                    
                }
            } else {
                $mypatch_model->changeStatePatching($file, $status = 'reset');
            }
        }
        
        ftp_close($connection);
        $mypatch_error['file_reset'] = $error;
        return $mypatch_error; 
    }

}


